/***************************************************************************
 * jtalk -- talk-like Jabber client
 * (C) Nicolas George - 2006
 * frontend_common.c: common startup function for front-ends
 ***************************************************************************/

/*
  This file is part of jtalk.

  jtalk is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  jtalk is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with jtalk; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "frontend_common.h"

#ifndef FRONTEND_DIR
# warning FRONTEND_DIR not defined, using default.
# define FRONTEND_DIR "/usr/local/libexec/jtalk"
#endif

static void
execv_3(const char *p1, const char *p2, const char *p3, char **argv)
{
    size_t l1 = strlen(p1);
    size_t l2 = strlen(p2);
    size_t l3 = strlen(p3);
    char p[l1 + l2 + l3 + 1];

    strcpy(p, p1);
    strcpy(p + l1, p2);
    strcpy(p + l1 + l2, p3);
    execv(p, argv);
}

void
jtalk_frontend_select(char **argv, int argc)
{
    (void)argc;
    char *fe;
    char *base;

    if((fe = getenv("JTALK_FRONTEND")) == NULL)
	return;
    execv(fe, argv);
    if((base = getenv("JTALK_FRONTEND_DIR")) == NULL)
	base = FRONTEND_DIR;
    execv_3(base, "/", fe, argv);
    execv_3(base, "/jtalk_", fe, argv);
    perror("Unable to exec $JTALK_FRONTEND");
}
